Gecode::Int::Channel::Base< Info, Offset, pc > Class Template Reference

Base-class for channel propagators. More...

`#include <channel.hh>`

## Public Member Functions

virtual PropCost | cost (const Space &home, const ModEventDelta &med) const
| Propagation cost (defined as low quadratic).
virtual void | reschedule (Space &home)
| Schedule function.
virtual size_t | dispose (Space &home)
| Delete propagator and return its size.
virtual ExecStatus | propagate (Space &home, const ModEventDelta &med)=0
| Propagation function.
ModEventDelta | modeventdelta (void) const
| Return the modification event delta.
virtual ExecStatus | advise (Space &home, Advisor &a, const Delta &d)
| Advise function.
virtual void | advise (Space &home, Advisor &a)
| Run advisor a to be run on failure in failed space.
double | afc (void) const
| Return the accumlated failure count.
unsigned int | id (void) const
| Return propagator id.
PropagatorGroup | group (void) const
| Return group propagator belongs to.
void | group (PropagatorGroup g)
| Add propagator to group g.
bool | disabled (void) const
| Whether propagator is currently disabled.
Public Member Functions inherited from Gecode::Actor
virtual Actor * | copy (Space &home)=0
| Create copy.
virtual | ~Actor (void)
| To avoid warnings.

## Protected Member Functions

| Base (Space &home, Base< Info, Offset, pc > &p)
| Constructor for cloning p.
| Base (Home home, int n, Info *xy, Offset &ox, Offset &oy)
| Constructor for posting.
Protected Member Functions inherited from Gecode::Propagator
| Propagator (Home home)
| Constructor for posting.
| Propagator (Space &home, Propagator &p)
| Constructor for cloning p.
Propagator * | fwd (void) const
| Return forwarding pointer during copying.
Kernel::GPI::Info & | gpi (void)
| Provide access to global propagator information.

## Protected Attributes

int | n
| Number of views (actually twice as many for both x and y).
int | n_na
| Total number of not assigned views (not known to be assigned).
Offset | ox
| Offset transformation for x variables.
Offset | oy
| Offset transformation for y variables.
Info * | xy
| View and information for both x and y.

## Additional Inherited Members

static void * | operator new (size_t s, Space &home)
| Allocate memory from space.
static void | operator delete (void *p, Space &home)
| No-op for exceptions.
static void * | operator new (size_t s)
| Not used.
static void | operator delete (void *p)
| Not used.

## Detailed Description

template<class Info, class Offset, PropCond pc>
class Gecode::Int::Channel::Base< Info, Offset, pc >

Base-class for channel propagators.

Definition at line 55 of file channel.hh.

## Constructor & Destructor Documentation

## Base() [1/2]

template<class Info, class Offset, PropCond pc>

Gecode::Int::Channel::Base< Info, Offset, pc >::Base | ( | Space & | home,
|  | Base< Info, Offset, pc > & | p )

inline protected

Constructor for cloning p.

Definition at line 47 of file base.hpp.

## Base() [2/2]

template<class Info, class Offset, PropCond pc>

Gecode::Int::Channel::Base< Info, Offset, pc >::Base | ( | Home | home,
|  | int | n,
|  | Info * | xy,
|  | Offset & | ox,
|  | Offset & | oy )

inline protected

Constructor for posting.

Definition at line 38 of file base.hpp.

## Member Function Documentation

## cost()

template<class Info, class Offset, PropCond pc>

PropCost Gecode::Int::Channel::Base< Info, Offset, pc >::cost | ( | const Space & | home,
|  | const ModEventDelta & | med ) const

virtual

Propagation cost (defined as low quadratic).

Implements Gecode::Propagator.

Reimplemented in Gecode::Int::Channel::Dom< View, Offset, shared >.

Definition at line 58 of file base.hpp.

## reschedule()

template<class Info, class Offset, PropCond pc>

void Gecode::Int::Channel::Base< Info, Offset, pc >::reschedule | ( | Space & | home | ) |

virtual

Schedule function.

Implements Gecode::Propagator.

Definition at line 64 of file base.hpp.

## dispose()

template<class Info, class Offset, PropCond pc>

size_t Gecode::Int::Channel::Base< Info, Offset, pc >::dispose | ( | Space & | home | ) |

inline virtual

Delete propagator and return its size.

Reimplemented from Gecode::Actor.

Definition at line 71 of file base.hpp.

## Member Data Documentation

## n

template<class Info, class Offset, PropCond pc>

int Gecode::Int::Channel::Base< Info, Offset, pc >::n

protected

Number of views (actually twice as many for both x and y).

Definition at line 58 of file channel.hh.

## n_na

template<class Info, class Offset, PropCond pc>

int Gecode::Int::Channel::Base< Info, Offset, pc >::n_na

protected

Total number of not assigned views (not known to be assigned).

Definition at line 60 of file channel.hh.

## ox

template<class Info, class Offset, PropCond pc>

Offset Gecode::Int::Channel::Base< Info, Offset, pc >::ox

protected

Offset transformation for x variables.

Definition at line 62 of file channel.hh.

## oy

template<class Info, class Offset, PropCond pc>

Offset Gecode::Int::Channel::Base< Info, Offset, pc >::oy

protected

Offset transformation for y variables.

Definition at line 64 of file channel.hh.

## xy

template<class Info, class Offset, PropCond pc>

Info* Gecode::Int::Channel::Base< Info, Offset, pc >::xy

protected

View and information for both x and y.

Definition at line 66 of file channel.hh.

The documentation for this class was generated from the following files:

- gecode/int/channel.hh
- gecode/int/channel/base.hpp